-- GLOBALS
KB_whisperMessage = ""
KB_whisperSender = ""
KB_whisperClass = 0
KB_applicants = {}
KB_applicants[0] = {}	

-- Invisibleframe to hold events
local whispers = CreateFrame("Frame", nil, UIParent)

local function addApplicant(dungeon, key, name, loot)
	for x = 1, #KB_applicants do
		if KB_applicants[x][2] == name then
			dungeon = C_ChallengeMode.GetMapInfo(dungeon)
				if dungeon == "Neltharion's Lair" then dungeon = "NL"
					elseif dungeon == "Eye of Azshara" then dungeon = "EoA"
					elseif dungeon == "Darkheart Thicket" then dungeon = "DH"
					elseif dungeon == "Halls of Valor" then dungeon = "HoV"
					elseif dungeon == "Vault of the Wardens" then dungeon = "VotW"
					elseif dungeon == "Black Rook Hold" then dungeon = "BRH"
					elseif dungeon == "Maw of Souls" then dungeon = "MoS"
					elseif dungeon == "Court of Stars" then dungeon = "CoS"
					elseif dungeon == "The Arcway" then dungeon = "ARC"
					elseif dungeon == "Return to Karazhan: Lower" then dungeon = "Lower"
					elseif dungeon == "Return to Karazhan: Upper" then dungeon = "Upper"
					elseif dungeon == "Cathedral of Eternal Night" then dungeon = "CoEN"
					elseif dungeon == "Eye of Azshara" then dungeon = "EoA"
				end
			KB_applicants[x][0] = dungeon
			KB_applicants[x][1] = key
			KB_applicants[x][3] = loot
			return
		end
	end
	dungeon = C_ChallengeMode.GetMapInfo(dungeon)
		if dungeon == "Neltharion's Lair" then dungeon = "NL"
			elseif dungeon == "Eye of Azshara" then dungeon = "EoA"
			elseif dungeon == "Darkheart Thicket" then dungeon = "DH"
			elseif dungeon == "Halls of Valor" then dungeon = "HoV"
			elseif dungeon == "Vault of the Wardens" then dungeon = "VotW"
			elseif dungeon == "Black Rook Hold" then dungeon = "BRH"
			elseif dungeon == "Maw of Souls" then dungeon = "MoS"
			elseif dungeon == "Court of Stars" then dungeon = "CoS"
			elseif dungeon == "The Arcway" then dungeon = "ARC"
			elseif dungeon == "Return to Karazhan: Lower" then dungeon = "Lower"
			elseif dungeon == "Return to Karazhan: Upper" then dungeon = "Upper"
			elseif dungeon == "Cathedral of Eternal Night" then dungeon = "CoEN"
			elseif dungeon == "Eye of Azshara" then dungeon = "EoA"
		end
	local number = #KB_applicants + 1 
	KB_applicants[number] = {}
	KB_applicants[number][0] = dungeon
	KB_applicants[number][1] = key
	KB_applicants[number][2] = name
	KB_applicants[number][3] = loot
	
	KB_premadeUpdate()
end


local function handleWhisper()
	originalLinkSubstring = strsub(KB_whisperMessage, 11, strfind(KB_whisperMessage, '|h') - 1)
	parts = { strsplit(':', originalLinkSubstring) }
	if(tonumber(parts[3]) > 2) then 
		dungeonID = tonumber(parts[2])
		keystoneLevel = tonumber(parts[3])
		local depleted = tonumber(parts[4])
		addApplicant(dungeonID, keystoneLevel, KB_whisperSender, depleted)
	end
end

local function handleWhisperBN()
	originalLinkSubstring = strsub(KB_whisperMessage, 11, strfind(KB_whisperMessage, '|h') - 1)
	parts = { strsplit(':', originalLinkSubstring) }
	if(tonumber(parts[3]) > 2) then 
		dungeonID = tonumber(parts[2])
		keystoneLevel = tonumber(parts[3])
		local depleted = tonumber(parts[4])
		addApplicant(dungeonID, keystoneLevel, KB_whisperSender, depleted)
	end
end

local function eventHandler(self, event, prefix, msg, channel, sender, presenceID)
	if event == 'LFG_LIST_APPLICANT_LIST_UPDATED' then
		KB_premadeUpdate()
	end
	if event == 'CHAT_MSG_WHISPER' then
		KB_whisperSender = msg
		KB_whisperMessage = prefix
		if pcall(handleWhisper) then
			--print("Success")
		else
			--print("Failure")
		end
	end
	if event == 'CHAT_MSG_BN_WHISPER'  then
		KB_whisperSender = msg
		KB_whisperMessage = prefix
		
		local _, numFreinds = BNGetNumFriends()
				
		for index = 1, numFreinds do
			local name = select(2, BNGetFriendInfo(index))
			if KB_whisperSender == name then
				local bnetIDGameAccount, client = select(6, BNGetFriendInfo(index))
				client = select(7, BNGetFriendInfo(index))
				if client == "WoW" then
					local _, characterName, _, realmName, _, faction, _, class = BNGetGameAccountInfo(bnetIDGameAccount)
					local factionGroup, factionName = UnitFactionGroup("player")
					if faction == factionGroup then
						KB_whisperSender = characterName.."-"..realmName
						if pcall(handleWhisperBN) then
							--print("Success")
						else
							--print("Failure")
						end
					end
				end
			end
		end
	end
end

function KB_ApplicantsClear()
	KB_applicants = {}
	KB_applicants[0] = {}
end

whispers:RegisterEvent('CHAT_MSG_WHISPER')
whispers:RegisterEvent('CHAT_MSG_BN_WHISPER')
whispers:RegisterEvent('LFG_LIST_APPLICANT_LIST_UPDATED')
whispers:SetScript('OnEvent', eventHandler)

-- TEST FUNCTIONS
function printApplicants()
	for x=1, #KB_applicants do
		print(KB_applicants[x][0])
		print(KB_applicants[x][1])
		print(KB_applicants[x][2])
		print(KB_applicants[x][3])
	end
end